//#include "stdafx.h"
#include <windows.h>
#include <winioctl.h>
#include <stdio.h>
//#include "MxGeneralIo.h"

#ifdef __cplusplus    // If used by C++ code, 
extern "C" {          // we need to export the C interface
#endif


/* DA720
   First release by Sean Hsieh 2016.05.31
   2 port(232/422/484)
*/


//#define UART_AUTODIRECTION_CONTROL_ADDRESS 0xF0  // In ITE Super IO

//#define UART_MODE_IO_ADDRESS 0x304 //General IO Address(GP51)
#define UART_AUTODIRECTION_CONTROL_ADDRESS 0xF0  // In ITE Super IO

#define UART_MODE_IO_ADDRESS 0x200 //General IO Address(GP51)
#define UART_MODE_BIT_COM1_RS232 3
#define UART_MODE_BIT_COM1_RS485 1
#define UART_MODE_BIT_COM1_RS422 2

#define UART_MODE_BIT_COM2_RS232 6
#define UART_MODE_BIT_COM2_RS485 4
#define UART_MODE_BIT_COM2_RS422 5


#define MAX_SERIAL_PORT_NUMBER			2
#define MAX_SERIAL_INTERFACE_NUMBER		4

typedef enum {
	RS4852W = 0,
	RS422,
	RS232
}UartMode;

int UartModeGet(int portNum);
int UartModeSet(int portNum, int portMode);
UCHAR ReadPortData(ULONG address);
int WritePortData(ULONG	address, UCHAR ucMemData);

//
int EnableAutoDirectionControl(int portNum);
int DisableAutoDirectionControl(int portNum);
int SetAutoDirectionControl(int portNum);
UCHAR ReadSuperIoChar(ULONG address, int portNum);
int WriteSuperIoChar(ULONG	address, int portNum, UCHAR	ucMemData);

int SetRegistryValue(DWORD nPort,DWORD nMode);
int GetRegistryValue(DWORD nPort,DWORD* nMode);

HANDLE mxsp_open();
void mxsp_close();
int mxsp_get_interface(HANDLE fd, int port_index);
int mxsp_set_interface(HANDLE fd, int port_index, int port_interface);
#ifdef __cplusplus    // If used by C++ code, 
}
#endif