

/*****************************************************************************
 *  Define	section												 			*
 ****************************************************************************/
//#define _WIN32_WINNT 0x0501	// Change this to the appropriate value to target other versions of Windows. 

/*****************************************************************************
 *  Include	section												 			*
 ****************************************************************************/
//#include "stdafx.h"
#include <stdio.h>
#include <windows.h>
#include <setupapi.h>
#include <devguid.h>
#include <regstr.h>
#include <TCHAR.h>
#include <WinIoctl.h>

/*****************************************************************************
 *  Self-defined function body	section							 			*
 ****************************************************************************/

/*	
 *	Description:
 *		Compare if drive letter and physical location is matched
 *
 *	Input:		
 *		<szAntecedentResult> : strings of disk numbers return from WMI calls
 *		<szDependentResult> : strings of drive letters return from WMI calls
 *		<szDiskNumber> : disk number of a volume. Ex. "Disk #0"
 *		<szDriveLetter> : drive letter of a volume. Ex. "D:\"
 *		
 *
 *	Output:
 *		None
 *
 *	Return:
 *		TRUE indicates success, FALSE indicates fail.
 */
BOOL split_disk_number_and_drive_letter(TCHAR* szAntecedentResult,TCHAR *szDependentResult,TCHAR *szDiskNumber,TCHAR *szDriveLetter)
{

	int i = 0;
	char strAntecedent[5][128]; 
	char strDependent[5][128]; 
	char *pch;
	char *delim = "\","; 
	printf ("Splitting szAntecedentResult string \"%s\" into tokens:\n",szAntecedentResult);
	printf ("Splitting szDependentResult string \"%s\" into tokens:\n",szDependentResult);

	// Split Antecedent string
	pch = strtok(szAntecedentResult,delim);
	while (pch != NULL)
	{
		memcpy(strAntecedent[i],pch,64);
		i++;
		
		pch = strtok (NULL, delim);
	}

	//printf ("strAntecedent[0] = %s\n",*strAntecedent);
	//printf ("strAntecedent[1] = %s\n",*(strAntecedent+1));
	//printf ("strAntecedent[2] = %s\n",*(strAntecedent+2));

	// Split Dependent string
	i = 0;
	pch = strtok(szDependentResult,delim);
	while (pch != NULL)
	{
		//printf ("pch = %s\n",pch);
		memcpy(strDependent[i],pch,64);
		//printf ("strDependent[%d] = %s\n",i,strDependent[i]);
		i++;
		
		pch = strtok (NULL, delim);
	}

	//printf ("strDependent[0] = %s\n",*strDependent);
	//printf ("strDependent[1] = %s\n",*(strDependent+1));
	//printf ("strDependent[2] = %s\n",*(strDependent+2));

	// Output the result 
	memcpy(szDiskNumber,*(strAntecedent+1),strlen(*(strAntecedent+1)));
	memcpy(szDriveLetter,*(strDependent+1),strlen(*(strDependent+1)));

	return TRUE;
}

/*	
 *	Description:
 *		Return Physical name according to disk number 
 *
 *	Input:		
 *		<szAnteDiskDriveToDiskPart> : strings of physical name to be compared
 *		<szDepDiskDriveToDiskPart> : strings of disk number to be compared
 *
 *	Output:
 *		<szPhysicalNmae> : Physical disk name 
 *		<szDiskNumber> : Disk number 
 *
 *	Return:
 *		TRUE indicates success, FALSE indicates fail.
 */
BOOL split_disk_physical_name_and_disk_number(TCHAR* szAnteDiskDriveToDiskPart,TCHAR *szDepDiskDriveToDiskPart,TCHAR *szPhysicalNmae,TCHAR *szDiskNumber)
{
	int i = 0;
	char strAntecedent[5][128]; 
	char strDependent[5][128]; 
	char *pch;
	char *delim = "\","; 
	//printf ("Splitting szDiskNumber string \"%s\" into tokens:\n",szAnteDiskDriveToDiskPart);
	

	// Split Antecedent string
	pch = strtok(szAnteDiskDriveToDiskPart,delim);
	while (pch != NULL)
	{
		memcpy(strAntecedent[i],pch,64);
		i++;
		
		pch = strtok (NULL, delim);
	}

	//printf ("strAntecedent[0] = %s\n",*strAntecedent);
	//printf ("strAntecedent[1] = %s\n",*(strAntecedent+1));
	//printf ("strAntecedent[2] = %s\n",*(strAntecedent+2));

	// Split Dependent string
	i = 0;
	pch = strtok(szDepDiskDriveToDiskPart,delim);
	while (pch != NULL)
	{
		//printf ("pch = %s\n",pch);
		memcpy(strDependent[i],pch,64);
		//printf ("strDependent[%d] = %s\n",i,strDependent[i]);
		i++;
		
		pch = strtok (NULL, delim);
	}

	//printf ("strDependent[0] = %s\n",*strDependent);
	//printf ("strDependent[1] = %s\n",*(strDependent+1));
	//printf ("strDependent[2] = %s\n",*(strDependent+2));

	// Output the result 
	memcpy(szPhysicalNmae,*(strAntecedent+1),strlen(*(strAntecedent+1)));
	memcpy(szDiskNumber,*(strDependent+1),strlen(*(strDependent+1)));

	return 0;
}

/*	
 *	Description:
 *		Return Physical name according to disk number 
 *
 *	Input:		
 *		<szDeviceIDDiskDrive> : strings of physical name to be compared
 *		<szSCSITargetIDDiskDrive> : strings of disk number to be compared
 *
 *	Output:
 *		<szPhysicalNmae> : Physical disk name 
 *		<scsiID> : slot id
 *
 *	Return:
 *		TRUE indicates success, FALSE indicates fail.
 */
BOOL split_disk_physical_name(TCHAR* szDeviceIDDiskDrive,TCHAR *szPhysicalNmae)
{
	int i = 0;
	char strAntecedent[5][128]; 
//	char strDependent[5][128]; 
	char *pch;
	char *delim = "\\\\.\\,"; 
	//printf ("Splitting szDiskNumber string \"%s\" into tokens:\n",szAnteDiskDriveToDiskPart);
	
	// Split Antecedent string
	pch = strtok(szDeviceIDDiskDrive,delim);
	while (pch != NULL)
	{
		memcpy(strAntecedent[i],pch,14);
		i++;
		
		pch = strtok (NULL, delim);
	}
	*(*(strAntecedent)+14) = '\0';
	//printf ("strAntecedent[0] = %s\n",*strAntecedent);
	//printf ("strAntecedent[1] = %s\n",*(strAntecedent+1));
	//printf ("strAntecedent[2] = %s\n",*(strAntecedent+2));



#if 0
	//	Split Dependent string
	i = 0;
	pch = strtok(szDepDiskDriveToDiskPart,delim);
	while (pch != NULL)
	{
		//printf ("pch = %s\n",pch);
		memcpy(strDependent[i],pch,64);
		//printf ("strDependent[%d] = %s\n",i,strDependent[i]);
		i++;
		
		pch = strtok (NULL, delim);
	}

	//printf ("strDependent[0] = %s\n",*strDependent);
	//printf ("strDependent[1] = %s\n",*(strDependent+1));
	//printf ("strDependent[2] = %s\n",*(strDependent+2));
#endif
	// Output the result 
	memcpy(szPhysicalNmae,*(strAntecedent),strlen(*(strAntecedent)));
	
	

	return 0;
}

